[POJ1952]BUY LOW, BUY LOWER


题目描述 Description


The advice to "buy low" is half the formula to success in the bovine stock market.To be considered a great investor you must also follow this problems‘ advice:

                    "Buy low; buy lower"

Each time you buy a stock, you must purchase it at a lower price than the previous time you bought it. The more times you buy at a lower price than before, the better! Your goal is to see how many times you can continue purchasing at ever lower prices.

You will be given the daily selling prices of a stock (positive 16-bit integers) over a period of time. You can choose to buy stock on any of the days. Each time you choose to buy, the price must be strictly lower than the previous time you bought stock. Write a program which identifies which days you should buy stock in order to maximize the number of times you buy.

Here is a list of stock prices:

 Day   1  2  3  4  5  6  7  8  9 10 11 12
Price 68 69 54 64 68 64 70 67 78 62 98 87

The best investor (by this problem, anyway) can buy at most four times if each purchase is lower then the previous purchase. One four day sequence (there might be others) of acceptable buys is:

Day    2  5  6 10
Price 69 68 64 62

输入描述 Input Description

* Line 1: N (1 <= N <= 5000), the number of days for which stock prices are given

* Lines 2..etc: A series of N space-separated integers, ten per line except the final line which might have fewer integers. 


输出描述 Output Description


Two integers on a single line: 
* The length of the longest sequence of decreasing prices 
* The number of sequences that have this length (guaranteed to fit in 31 bits)

In counting the number of solutions, two potential solutions are considered the same (and would only count as one solution) if they repeat the same string of decreasing prices, that is, if they "look the same" when the successive prices are compared. Thus, two different sequence of "buy" days could produce the same string of decreasing prices and be counted as only a single solution.


样例输入 Sample Input

12
68 69 54 64 68 64 70 67 78 62
98 87

样例输出 Sample Output

4 2

数据范围及提示 Data Size & Hint

 

之前的一些废话:近日诸事不顺。

题解:对于第一问我们xjb做一遍最长下降子序列即可,对于方案数,在转移的时候顺便计算一下,注意如果发现a[i]=a[j],就要把cnt[i]标记成0,来做到去重。

代码:

#include<iostream>
#include<algorithm>
#include<cstdio>
#include<cstring>
#include<cmath>
#include<set>
#include<queue>
using namespace std;
typedef long long LL;
typedef pair<int,int> PII;
#define mem(a,b) memset(a,b,sizeof(a))
inline int read()
{
    int x=0,f=1;char c=getchar();
    while(!isdigit(c)){if(c==‘-‘)f=-1;c=getchar();}
    while(isdigit(c)){x=x*10+c-‘0‘;c=getchar();}
    return x*f;
}
const int maxn=5010;
int n,a[maxn],dp[maxn],ans,cnt,dp2[maxn];
int main()
{
    n=read();
    for(int i=1;i<=n;i++)a[i]=read(),dp[i]=dp2[i]=1;
    for(int i=2;i<=n;i++)
        for(int j=1;j<i;j++)
        {
            if(a[i]<a[j])
            {
                if(dp[j]+1>dp[i])dp[i]=dp[j]+1,dp2[i]=dp2[j];
                else if(dp[j]+1==dp[i])dp2[i]+=dp2[j];
            }
            else if(a[i]==a[j])dp2[i]=0;
       }
    for(int i=1;i<=n;i++)ans=max(ans,dp[i]);
    for(int i=1;i<=n;i++)if(ans==dp[i])cnt+=dp2[i];
    printf("%d %d\n",ans,cnt);
    return 0;
}

总结:

时间: 2024-09-29 23:05:12

[POJ1952]BUY LOW, BUY LOWER的相关文章

USACO Section 4.3 Buy low,Buy lower

第一眼看到题目,感觉水水的,不就是最长下降子序列嘛!然后写……就呵呵了..要判重,还要高精度……判重我是在计算中加入各种判断.这道题比看上去麻烦一点,但其实还好吧.. #include<cstdio> #include<cstring> #include<iostream> #include<algorithm> #define rep(i,l,r) for(int i=l;i<r;i++) #define clr(x,c) memset(x,c,si

POJ 1952 BUY LOW, BUY LOWER

BUY LOW, BUY LOWER Time Limit: 1000MS   Memory Limit: 30000K Total Submissions: 8311   Accepted: 2883 Description The advice to "buy low" is half the formula to success in the bovine stock market.To be considered a great investor you must also f

【dp】PKU 1952 buy low,buy lower

题目链接: http://poj.org/problem?id=1952 Usaco 4.3.1 Buy Low, Buy Lower By 小兔齐齐 描述 “逢低吸纳”是炒股的一条成功秘诀.如果你想成为一个成功的投资者,就要遵守这条秘诀: "逢低吸纳,越低越买" 这句话的意思是:每次你购买股票时的股价一定要比你上次购买时的股价低.按照这个规则购买股票的次数越多越好,看看你最多能按这个规则买几次. 给定连续的N天中每天的股价.你可以在任何一天购买一次股票,但是购买时的股价一定要比你上次

POJ 1952 BUY LOW, BUY LOWER 动态规划题解

Description The advice to "buy low" is half the formula to success in the bovine stock market.To be considered a great investor you must also follow this problems' advice: "Buy low; buy lower" Each time you buy a stock, you must purcha

poj 1952 BUY LOW, BUY LOWER (最长递减子序列+不同子序列计数)

BUY LOW, BUY LOWER Time Limit: 1000MS   Memory Limit: 30000K Total Submissions: 8327   Accepted: 2888 Description The advice to "buy low" is half the formula to success in the bovine stock market.To be considered a great investor you must also f

算法练习 - Buy Low, Buy Lower - USACO

这道题目本身很简单,倒推回去,第K个是最优时,K+1时必然包含它.所以就从最后面的股票开始贪心法用最优解生成最优解. 难点1是去重,我直接用了个价格表去过滤,如果多个价格相等的同级最优解,就用他们中可能性最大的那个累加,其余的忽略. 难点2是大数计算.可能性可能有几十位的数字,所以封装了一个大数类.现在还不支持符号,只支持正数.后面需要用到负数的时候再说. 题目: Buy Low, Buy Lower The advice to "buy low" is half the formul

poj 1952 BUY LOW, BUY LOWER 最长下降子序列+统计不重复方案数

dp[i]=max(dp[i],dp[j]+1) j<i且a[j]>a[i] dp[i]表示长度为i的最长下降子序列的长度. r[i]表示长度为i的最长下降子序列的方案数. 考虑这样一个问题,比如6 3 9 3,对于两个3,他们数字一样并且dp值也一样,那么r[2]的方案数是没有意义的 因为能通过第一个3扩展的也能通过第二个3扩展,所以直接把r[2]=0. 对于一次扩展若dp[j]+1==dp[i],则说明j的路线和i的路线都可以用则r[i]+=r[j] 若dp[j]+1>dp[i],则

poj 1952 BUY LOW, BUY LOWER[最长单调子序列变形]

题目:poj 1952 BUY LOW, BUY LOWER 题意:给出一个序列,先求最长单调递减子序列,然后求在子序列最长的情况下,不同的长度都为最长的的子序列的个数.(比如3,2,1和3,2,1属于相同,只能算一个) 分析:首先用一个dp[i]表示到当前i点的最长子序列的长度 用dp2[i]表示最长为dp[i]的子序列的个数 然后dp[i] = max(dp[j])+1 (1<=j /************************************ Problem: 1952 Use

POJ 1552 BUY LOW, BUY LOWER(最长单调递减子序列求方案数)

BUY LOW, BUY LOWER Time Limit: 1000MS   Memory Limit: 30000K       Description The advice to "buy low" is half the formula to success in the bovine stock market.To be considered a great investor you must also follow this problems' advice: "